* Roger,
* what I change, is marked with *** P.D. 2002.10.01
* I have correct creating of pushbuttons. The size is now dynamically,
* depend on lenght of caption. Size of memoedit window is controlled,
* to be not to small (in this case in original source, the pushbuttons
* going one to another). Size of XbpStatic is controlled in area of
* language depended text.                       //
* With special thanks for your help, when I tested and learn Express
*
* Piotr Dziurla
************************************************************************

/*
 ķ
   Program..: _DCMEMOE.PRG                          
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2000 
   Date.....: May 30, 2000                          
   Notes....: Mouseable replacement for MEMOEDIT()  
                                                    
   Functions:  dc_memoedit(), dc_memomouse()          //
               dc_guimemoedit(), dc_guimemohelp()   
               dc_guimemonav()                      
 Ľ

// Function/Procedure Prototype Table  -  Last Update: 5/15/2003 @ 11:11:51AM*/
// --------------------------------------------------------------------------
// Return Value         Function/Arguments
// -------------------  -----------------------------------------------------
// nil                  METHOD Init, Create
// cMemo                FUNCTION DC_GuiMemoEdit( cMemo, nTop, nLeft, nBottom, nRight, lEditMode, ;
// nil                  FUNCTION DC_GuiMemoHelp()
// 0                    FUNCTION DC_GuiMemoNav ( mp1, mp2, oMLE, nRows )
// cString              FUNCTION dc_memoedit ( cString, nTop, nLeft, nBottom, nRight, lEditMode, ;



#include 'inkey.ch'
#include 'common.ch'
#include 'gra.ch'
#include 'appevent.ch'
#include 'xbp.ch'
#include 'dcdialog.ch'
#include 'dcmsg.ch'
#include 'font.ch'

#define nMEMOTOP       aOptions[1]
#define nMEMOLEFT      aOptions[2]
#define nMEMOBOTTOM    aOptions[3]
#define nMEMORIGHT     aOptions[4]
#define nABORTKEY      aOptions[5]
#define lEDITMODE      aOptions[6]
#define nCLICKKEY      aOptions[7]
#define aBUTTONS       aOptions[8]

#pragma Oem2Ansi(ON)

STATIC aOptions

FUNCTION dc_memoedit ( cString, nTop, nLeft, nBottom, nRight, lEditMode, ;
      cUserFunction, nLineLength, nTabSize, nTextRow,;
      nTextCol, nWindowRow, nWindowCol, cHeading, oDlg, ;
      lDestroy, lModal )

   LOCAL nMouseRow, nMouseCol, nCursor, bMouseKey

   IF DC_Gui()
      cString := DC_GuiMemoEdit ( cString, nTop, nLeft, nBottom, nRight, lEditMode, ;
         cUserFunction, nLineLength, nTabSize, nTextRow,;
         nTextCol, nWindowRow, nWindowCol, cHeading, @oDlg, lDestroy, lModal )
   ELSE
      cString := MemoEdit( cString, nTop, nLeft, nBottom, nRight, lEditMode, ;
         cUserFunction, nLineLength, nTabSize, nTextRow,;
         nTextCol, nWindowRow, nWindowCol )
   ENDIF


RETURN cString

/* -------------------------------- */

FUNCTION DC_GuiMemoEdit( cMemo, nTop, nLeft, nBottom, nRight, lEditMode, ;
      bcUserFunc, nLineLen, nTabSize, nTextRow,;
      nTextCol, nWinRow, nWinCol, cHeading, oDlg, lDestroy, lWordWrap, ;
      lModal )

   LOCAL oParent, nCol, nRow, oMle, nWidth, nHeight, nEvent, ;
      mp1, mp2, oXbp, drawingArea, lEdited := .f., lAbort := .f., ;
      cMemoSave, oStatRow, oStatCol, nStatRow, nStatCol, oStatic, ;
      nPos, nBegPos, nLenCaption, oOwner
   *** P.D. 2002.10.01 added nBegPos and nLenCaption to determine
   *** position of pushbutton and length of caption

   DEFAULT cMemo TO ''
   DEFAULT cHeading TO ''
   DEFAULT lEditMode TO .t.
   DEFAULT nTop TO 0
   DEFAULT nBottom TO 24
   DEFAULT nLeft TO 0
   DEFAULT nRight TO 80
   DEFAULT nTabSize TO 4
   DEFAULT nTextRow TO 1
   DEFAULT nTextCol TO 1
   DEFAULT nWinRow TO 1
   DEFAULT nWinCol TO 1
   DEFAULT nLineLen TO 0
   DEFAULT lDestroy TO .T.
   DEFAULT lWordWrap TO .t.
   DEFAULT lModal TO .t.

   nWidth := ( ( nRight - nLeft ) * 6.5 ) + 40
   nHeight := ( ( nBottom - nTop ) * 16 ) + 80

   *** P.D. 2002.10.01
   * test, if nWidth is greater as width of pushbuttons + XbpStatic
   *
   nWidth:=Max(nWidth,DC_GraQueryTextBox(DC_LangMsg(IF(lEditMode,DCMSG_SAVE,DCMSG_EXIT )),"8.Courier")[1]+16+;
      IF(lEditMode,DC_GraQueryTextBox(DC_LangMsg(DCMSG_CANCEL ),"8.Courier")[1]+16+;
      DC_GraQueryTextBox(DC_LangMsg(DCMSG_HELP ),"8.Courier")[1]+6,0)+;
      DC_GraQueryTextBox(DC_LangMsg(DCMSG_PC_ROWS )+;
      DC_LangMsg(DCMSG_PC_COLUMNS ),"8.Helv")[1]+140)

   oParent := SetAppWindow():setParent()
   IF Valtype(oParent) # 'O'
      oParent := AppDeskTop()
   ENDIF
   nCol := (oParent:currentSize()[1]-nWidth)/2
   nRow := (oParent:currentSize()[2]-nHeight)/2
   oOwner := SetAppWindow()

   cMemoSave := cMemo

   oDlg := XbpDialog():new( oParent, oOwner, { nCol, nRow }, { nWidth+30,nHeight+30 }, , .F.)
   oDlg:taskList := .T.
   oDlg:title := cHeading
   oDlg:visible := .F.
   oDlg:icon := DC_IconDefault()
   oDlg:create()
   IF lModal
      oDlg:setModalState(XBP_DISP_APPMODAL)
   ENDIF
   drawingArea := oDlg:drawingArea
   drawingArea:setColorBG( GRA_CLR_PALEGRAY   )
   drawingArea:setFontCompoundName( "8.Courier" )

   IF DC_LangSet() = DCLANG_CHINESE
      oMle := DC_XbpMLEC():new( drawingArea, , { 10,45 }, ;
         { oDlg:currentSize()[1]-30, oDlg:currentSize()[2]-80 } )
   ELSE
      oMle := DC_XbpMLE():new( drawingArea, , { 10,45 }, ;
         { oDlg:currentSize()[1]-30, oDlg:currentSize()[2]-80 } )
   ENDIF

   oMle:setFontCompoundName( "8.Courier" )
   oMle:clipSiblings := .T.
   IF lWordWrap
      oMle:wordWrap := .t.
      oMle:horizScroll := .f.
   ENDIF
   oMle:setEditable(lEditMode)
   oMle:create()
   oMle:setData(cMemo)
   oMle:border := .t.

   oDlg:reSize := {|a,b,o|oMle:setSize({drawingArea:currentSize()[1]-20,drawingArea:currentSize()[2]-60})}

   *** P.D. 2002.10.01
   nLenCaption:=DC_GraQueryTextBox(DC_LangMsg(IF(lEditMode,DCMSG_SAVE,DCMSG_EXIT )),"8.Courier")[1]+6

   oXbp := XbpPushButton():new(drawingArea,,{ 10,10 }, { nLenCaption,20 } )
   nBegPos:=10+nLenCaption+10                   && Begin position for next pushbutton
   oXbp:caption := DC_LangMsg(IIF( lEditMode,DCMSG_SAVE,DCMSG_EXIT ))
   oXbp:activate := {||lAbort := .f., PostAppEvent(xbeP_Close,,,oDlg)}
   oXbp:create()

   IF lEditMode

      nLenCaption:=DC_GraQueryTextBox(DC_LangMsg(DCMSG_CANCEL ),"8.Courier")[1]+6
      oXbp := XbpPushButton():new(drawingArea,,{ nBegPos,10 }, { nLenCaption,20 } )
      nBegPos:=nBegPos+nLenCaption+10           && Begin position for next pushbutton
      oXbp:caption := DC_LangMsg(DCMSG_CANCEL )
      oXbp:activate := {||lAbort := .t., PostAppEvent(xbeP_Close,,,oDlg)}
      oXbp:create()

      nLenCaption:=DC_GraQueryTextBox(DC_LangMsg(DCMSG_HELP ),"8.Courier")[1]+6
      oXbp := XbpPushButton():new(drawingArea,,{ nBegPos,10 }, { nLenCaption,20 } )
      nBegPos:=nBegPos+nLenCaption+10           && Begin position for next pushbutton
      oXbp:caption := DC_LangMsg(DCMSG_HELP )
      oXbp:activate := {||DC_GuiMemoHelp()}
      oXbp:create()

   ENDIF
   *** P.D. 2002.10.01
   * Compute len of XbpStatic:
   * lenght of language depend text + 2*30 (row/col as number) + distance between
   nLenCaption:=DC_GraQueryTextBox(DC_LangMsg(DCMSG_PC_ROWS )+;
      DC_LangMsg(DCMSG_PC_COLUMNS ),"8.Helv")[1]+30+30+10+10+20+15+5

   oStatic := XbpStatic():new(drawingArea,, ;
      { oDlg:currentSize()[1]-nLenCaption-20, 10 }, { nLenCaption,20 } )
   oStatic:type := XBPSTATIC_TYPE_RAISEDBOX
   oStatic:create()

   nLenCaption:=DC_GraQueryTextBox(DC_LangMsg(DCMSG_PC_ROWS ),"8.Helv")[1]+6
   oXbp := XbpStatic():new(oStatic,,{10,2},{nLenCaption,16})
   nBegPos:=10+nLenCaption+4
   oXbp:type := XBPSTATIC_TYPE_TEXT
   oXbp:setFontCompoundName( "8.Helv" )
   oXbp:caption := DC_LangMsg(DCMSG_PC_ROWS )
   oXbp:create()

   oStatRow := XbpStatic():new(oStatic,,{nBegPos,2},{30,16})
   nBegPos:=nBegPos+30+20
   oStatRow:type := XBPSTATIC_TYPE_TEXT
   oStatRow:setFontCompoundName( "10.Courier.Bold" )
   oStatRow:caption := '1'
   oStatRow:create()

   nLenCaption:=DC_GraQueryTextBox(DC_LangMsg(DCMSG_PC_COLUMNS ),"8.Helv")[1]+6
   oXbp := XbpStatic():new(oStatic,,{nBegPos,2},{nLenCaption,16})
   nBegPos:=nBegPos+nLenCaption+9
   oXbp:type := XBPSTATIC_TYPE_TEXT
   oXbp:setFontCompoundName( "8.Helv" )
   oXbp:caption := DC_LangMsg(DCMSG_PC_COLUMNS )
   oXbp:create()

   oStatCol := XbpStatic():new(oStatic,,{nBegPos,2},{30,16})
   oStatCol:type := XBPSTATIC_TYPE_TEXT
   oStatCol:setFontCompoundName( "10.Courier.Bold" )
   oStatCol:caption := '1'
   oStatCol:create()

   oMle:show()
   oDlg:show()

   IF Valtype( bcUserFunc ) == "C"              // Compile user function to
      bcUserFunc := &("{|o1,o2|"+bcUserFunc + "(o1,o2)}")
   ELSEIF Valtype( bcUserFunc ) <> "B"          // Set user function codeblock to NIL
      bcUserFunc := NIL                         // (for compatibility reasons)
   ENDIF

   SetAppFocus(oMle)
   oMle:setMarked({1,1})

   nEvent := xbeP_None
   DO WHILE nEvent # xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
      IF nEvent = xbeP_Close
         IF !lEdited
            EXIT
         ELSEIF DC_MsgBox(,,{DC_LangMsg(DCMSG_ABORTQUERY)},,,,.t.)
            lAbort := .t.
            EXIT
         ELSE
            LOOP
         ENDIF
      ENDIF
      IF oXbp == oMle .AND. nEvent == xbeP_Keyboard
         DC_GuiMemoNav( mp1, mp2, oXbp, nBottom-nTop+1 )
      ENDIF
      IF (nEvent = xbeM_Motion .AND. mp1 == NIL) .OR. Valtype(oXbp) # 'O'
         LOOP
      ENDIF
      oXbp:handleEvent( nEvent, mp1, mp2 )
      IF nEvent = xbeP_Keyboard
         IF mp1 = K_ESC
            IF !lEdited
               EXIT
            ELSEIF DC_MsgBox(,,{DC_LangMsg(DCMSG_ABORTQUERY)},,,,.t.)
               lAbort := .t.
               EXIT
            ENDIF
            LOOP
         ELSEIF mp1 = K_CTRL_W .OR. mp1 = xbeK_CTRL_W
            IF !lEdited
               EXIT
            ELSEIF DC_MsgBox(,,{DC_LangMsg(DCMSG_EXITQUERY)},,,,.t.)
               EXIT
            ENDIF
            LOOP
         ELSEIF Valtype(bcUserFunc) = 'B' .AND. ;
               ( (mp1 >= xbeK_F1 .AND. mp1 <= xbeK_F12) .OR. ;
                 (mp1 >= xbeK_CTRL_F1 .AND. mp1 <= xbeK_CTRL_F12) .OR. ;
                 (mp1 >= xbeK_ALT_F1 .AND. mp1 <= xbeK_ALT_F12) .OR. ;
                 (mp1 >= xbeK_ALT_A .AND. mp1 <= xbeK_ALT_Z) )
            Eval( bcUserFunc, mp1, oMle )
         ENDIF
      ELSEIF nEvent = xbeP_Resize .AND. oXbp == oDlg
         /*
         cMemo := oMle:GetData()

         oMle:setSize(oDlg:drawingArea:currentSize())
         oMle:configure(,,{ 10,45 }, ;
            { oDlg:currentSize()[1]-30, oDlg:currentSize()[2]-80 } )
         oMle:setData(cMemo)
         SetAppFocus(oMle)
         */
      ENDIF
      nRow := oMle:lineFromChar( oMle:pos() )
      nPos := oMle:charFromLine( nRow )
      nCol := oMle:pos() - nPos + 1
      oStatRow:SetCaption( Str(nRow,4) )
      oStatCol:SetCaption( Str(nCol,4) )
   ENDDO
   IF lAbort
      cMemo := cMemoSave
   ELSE
      cMemo := oMle:GetData()
   ENDIF

   IF lDestroy
      oDlg:setModalState(XBP_DISP_MODELESS)
      oDlg:Destroy()
   ENDIF

RETURN cMemo


/* ---------------------- */

FUNCTION DC_GuiMemoNav ( mp1, mp2, oMLE, nRows )

   LOCAL aInkey := {}, i, oAppFocus := SetAppFocus(), nNewPos, nCurrPos, ;
      nStartPos, nCurrCol, nCurrRow, nEndPos, nNewStartPos, nNewEndPos, ;
      cBuffer, nStartRow

   IF Valtype(nRows) # 'N'
      nRows := oMLE:CurrentSize()[2]/20
   ENDIF
   nCurrPos  := oMle:pos()
   nCurrRow  := oMle:lineFromChar( nCurrPos )
   nStartPos := oMle:charFromLine( nCurrRow )
   nCurrCol  := nCurrPos - nStartPos + 1
   nEndPos   := oMLE:charFromLine( nCurrRow + 1)
   cBuffer   := oMLE:editBuffer()

   DO CASE

   CASE mp1 = K_CTRL_H .OR. mp1 = xbeK_CTRL_H   // Backspace

   CASE mp1 = K_CTRL_G .OR. mp1 = xbeK_CTRL_G   // Delete Char
      oMLE:setMarked( { nCurrPos, nCurrPos+1 } )
      oMLE:deleteMarked()

   CASE mp1 = K_CTRL_E .OR. mp1 = xbeK_CTRL_E   // Up one line
      nNewStartPos := oMle:charFromLine( nCurrRow - 1 )
      nNewEndPos   := oMle:charFromLine( nCurrRow )
      IF ( nNewStartPos + nCurrCol - 1 ) > nNewEndPos
         nCurrPos := nNewEndPos - 1
      ELSE
         nCurrPos := nNewStartPos + nCurrCol - 1
      ENDIF
      oMLE:setMarked({ nCurrPos, nCurrPos })

   CASE mp1 = K_CTRL_X .OR. mp1 = xbeK_CTRL_X   // Down one line
      nNewStartPos := oMle:charFromLine( nCurrRow + 1 )
      nNewEndPos   := oMle:charFromLine( nCurrRow + 2 )
      IF ( nNewStartPos + nCurrCol - 1 ) > nNewEndPos
         nCurrPos := nNewEndPos - 1
      ELSE
         nCurrPos := nNewStartPos + nCurrCol - 1
      ENDIF
      oMLE:setMarked({ nCurrPos, nCurrPos })

   CASE mp1 = K_CTRL_R .OR. mp1 = xbeK_CTRL_R   // Up one page
      nNewStartPos := oMle:charFromLine( nCurrRow - nRows )
      nNewEndPos   := oMle:charFromLine( nCurrRow - nRows + 1 )
      IF ( nNewStartPos + nCurrCol - 1 ) > nNewEndPos
         nCurrPos := nNewEndPos - 1
      ELSE
         nCurrPos := nNewStartPos + nCurrCol - 1
      ENDIF
      IF nCurrPos < 1
         nCurrPos := 1
      ENDIF
      oMLE:setMarked({ nCurrPos, nCurrPos })

   CASE mp1 = K_CTRL_C .OR. mp1 = xbeK_CTRL_C   // Down one page
      nNewStartPos := oMle:charFromLine( nCurrRow + nRows )
      nNewEndPos   := oMle:charFromLine( nCurrRow + nRows + 1 )
      IF nNewEndPos = 0
         nCurrPos := Len(cBuffer)
      ELSEIF ( nNewStartPos + nCurrCol - 1 ) > nNewEndPos
         nCurrPos := nNewEndPos - 1
      ELSE
         nCurrPos := nNewStartPos + nCurrCol - 1
      ENDIF
      IF nCurrPos > Len(cBuffer)
         nCurrPos := Len(cBuffer)
      ENDIF
      oMLE:setMarked({ nCurrPos, nCurrPos })

   CASE mp1 = K_CTRL_S .OR. mp1 = xbeK_CTRL_S   // Left one char
      nCurrPos--
      oMLE:setMarked({ nCurrPos, nCurrPos })

   CASE mp1 = K_CTRL_D .OR. mp1 = xbeK_CTRL_D   // Right one char
      nCurrPos++
      oMLE:setMarked({ nCurrPos, nCurrPos })

   CASE mp1 = K_CTRL_A .OR. mp1 = xbeK_CTRL_A   // Left one word
      nCurrPos--
      DO WHILE ( SubStr(cBuffer,nCurrPos,1) $ ' ' + Chr(10) + Chr(13) ) ;
            .AND. nCurrPos > 1
         nCurrPos--
      ENDDO
      DO WHILE !( SubStr(cBuffer,nCurrPos,1) $ ' ' + Chr(10) + Chr(13) ) ;
            .AND. nCurrPos > 1
         nCurrPos--
      ENDDO
      nCurrPos++
      oMle:setMarked({nCurrPos,nCurrPos})

   CASE mp1 = K_CTRL_F .OR. mp1 = xbeK_CTRL_F   // Right one word
      nCurrPos++
      DO WHILE !( SubStr(cBuffer,nCurrPos,1) $ ' ' + Chr(10) + Chr(13) ) ;
            .AND. nCurrPos < Len(cBuffer)
         nCurrPos++
      ENDDO
      DO WHILE ( SubStr(cBuffer,nCurrPos,1) $ ' ' + Chr(10) + Chr(13) ) ;
            .AND. nCurrPos < Len(cBuffer)
         nCurrPos++
      ENDDO
      nCurrPos--
      oMle:setMarked({nCurrPos,nCurrPos})

   CASE mp1 = K_CTRL_T .OR. mp1 = xbeK_CTRL_T   // Delete Word Right
      nStartPos := nCurrPos
      nCurrPos++
      DO WHILE !( SubStr(cBuffer,nCurrPos,1) $ ' ' + Chr(10) + Chr(13) ) ;
            .AND. nCurrPos < Len(cBuffer)
         nCurrPos++
      ENDDO
      DO WHILE ( SubStr(cBuffer,nCurrPos,1) $ ' ' + Chr(10) + Chr(13) ) ;
            .AND. nCurrPos < Len(cBuffer)
         nCurrPos++
      ENDDO
      oMle:setMarked({nStartPos,nCurrPos})
      oMle:deleteMarked()

   CASE mp1 = K_CTRL_V .OR. mp1 = xbeK_CTRL_V   // Toggle insert
      aInkey := { xbeK_INS }

   CASE mp1 = K_CTRL_N .OR. mp1 = xbeK_CTRL_N   // Insert new line
      oMLE:insert( nStartPos, Chr(13)+Chr(10) )

   CASE mp1 = K_CTRL_Y .OR. mp1 = xbeK_CTRL_Y   // Delete line
      oMLE:setMarked( { nStartPos, nEndPos } )
      oMLE:deleteMarked()

   OTHERWISE
      RETURN 0

   ENDCASE

   nCurrPos  := oMLE:pos()
   nStartRow := oMLE:queryFirstChar()
   nCurrRow  := oMle:lineFromChar( nCurrPos )

   IF nCurrRow < nStartRow .OR. nCurrRow > ( nStartRow + nRows - 1 )
      oMLE:insert(nCurrPos,' ')
      oMLE:setMarked({nCurrPos,nCurrPos+1})
      oMLE:deleteMarked()
   ENDIF

   SetAppFocus(oAppFocus)

RETURN 0


/* ------------------------- */

FUNCTION DC_GuiMemoHelp()

   LOCAL cCrlf := CHR(13)+CHR(10), cCrlf2, cText, oDialog, oMle, nEvent,;
      oParent, nCol, nRow, drawingArea, oXbp, mp1, mp2, oButton

   cCrlf2 := cCrlf + cCrlf

   IF DC_LangSet() = DCLANG_POLISH
      cText := ;
         ' Klawisz                 Dziaanie' + cCrlf + ;
         ' ------------------      -------------------------------------------' + cCrlf2 + ;
         ' Lewa strzaka           Przesu kursor 1 znak w lewo' + cCrlf2 + ;
         ' Shift+Lewa strzaka     Zaznacz 1 znak na lewo' + cCrlf2 + ;
         ' Shift+Ctrl+Lewa strz.   Zaznacz 1 sowo na lewo' + cCrlf2 + ;
         ' Prawa strzaka          Przesu kursor 1 znak w prawo' + cCrlf2 + ;
         ' Shift+Prawa Strzaka    Zaznacz 1 znak na prawo' + cCrlf2 + ;
         ' Shift+Ctrl+Prawa strz.  Zaznacz 1 sowo na prawo' + cCrlf2 + ;
         ' Strzaka w gr         Przejd 1 wiersz w gr' + cCrlf2 + ;
         ' Shift+Strzaka w gr   Zaznacz 1 wiersz w gr' + cCrlf2 + ;
         ' Strzaka w d          Przejd 1 wiersz w d' + cCrlf2 + ;
         ' Shift+Strzaka w d    Zaznacz 1 wiersz w d' + cCrlf2 + ;
         ' Page Up                 Przejd 1 stron w gr' + cCrlf2 + ;
         ' Ctrl+Page Up            Przesu stron w lewo' + cCrlf2 + ;
         ' Page Down               Przejd 1 stron w d' + cCrlf2 + ;
         ' Ctrl+Page Down          Przesu stron w prawo' + cCrlf2 + ;
         ' Home                    Przejd do pocztku wiersza' + cCrlf2 + ;
         ' Shift+Home              Zaznacz tekst od pocztku biecej linii' + cCrlf2 + ;
         ' Ctrl+Home               Przejd do pocztku tekstu' + cCrlf2 + ;
         ' Shift+Ctrl+Home         Zaznacz tekst od pocztku do biecej pozycji' + cCrlf2 + ;
         ' End                     Przejd na koniec wiersza' + cCrlf2 + ;
         ' Shift+End               Zaznacz tekst do koca biecej linii' + cCrlf2 + ;
         ' Ctrl+End                Przejd na koniec tekstu' + cCrlf2 + ;
         ' Shift+Ctrl+End          Zaznacz tekst od biecej pozycji do koca' + cCrlf2 + ;
         ' Backspace               Usu znak na lewo od kursora' + cCrlf2 + ;
         ' Insert                  Przecz midzy "Wstawianiem" i "Nadpisywaniem"' + cCrlf2 + ;
         ' Shift+Insert            Usu zaznaczony tekst i zastp go tekstem' + cCrlf + ;
         '                         ze schowka' + cCrlf2 + ;
         ' Ctrl+Insert             Kopiuj zaznaczony tekst do schowka' + cCrlf2 + ;
         ' Delete                  Usu znak na prawo od kursora lub usu' + cCrlf + ;
         '                         zaznaczony tekst bez kopiowania go do schowka' + cCrlf+ ;
         ' Shift+Delete            Usu zaznaczony tekst i skopiuj go do schowka' + cCrlf2 + ;
         ' Tab                     Zapisywany jako znak w tekcie' + cCrlf2 + ;
         ' Inne klawisze           Inne klawisze wprowadzaj do tekstu' + cCrlf + ;
         '                         odpowiadajce im znaki' + cCrlf

   ELSEIF DC_LangSet() = DCLANG_SLOVAK

      cText := ;
         ' Klvesa                 Popis' + cCrlf + ;
         ' ------------------      -------------------------------------------' + cCrlf2 + ;
         ' pka vavo             Posunie kurzor o 1 znak doava ' + cCrlf2 + ;
         ' Shift+pka vavo       Ozna 1 znak vavo' + cCrlf2 + ;
         ' Shift+Ctrl+pka vavo  Ozna 1 slovo vavo' + cCrlf2 + ;
         ' pka vpravo            Posunie kurzor o 1 znak doprava' + cCrlf2 + ;
         ' Shift+pka vpravo      Ozna 1 znak vpravo' + cCrlf2 + ;
         ' Shift+Ctrl+pka vpr.   Ozna 1 slovo vpravo' + cCrlf2 + ;
         ' pka hore              Posun o 1 riadok hore' + cCrlf2 + ;
         ' Shift+pka hore        Ozna 1 riadok hore' + cCrlf2 + ;
         ' pka dole              Posun o 1 riadok dole' + cCrlf2 + ;
         ' Shift+pka dole        Ozna 1 riadok dole' + cCrlf2 + ;
         ' Page Up                 Posun o 1 stranu hore' + cCrlf2 + ;
         ' Ctrl+Page Up            Posun o 1 stranu doava' + cCrlf2 + ;
         ' Page Down               Posun o 1 stranu dole' + cCrlf2 + ;
         ' Ctrl+Page Down          Posun o 1 stranu doprava' + cCrlf2 + ;
         ' Home                    Posun na zaiatok riadku' + cCrlf2 + ;
         ' Shift+Home              Ozna vetky znaky do zaiatku riadku' + cCrlf2 + ;
         ' Ctrl+Home               Presun na zaiatok textu' + cCrlf2 + ;
         ' Shift+Ctrl+Home         Ozna text od zaiatku do aktulnej pozcie' + cCrlf2 + ;
         ' End                     Posun na konec riadku' + cCrlf2 + ;
         ' Shift+End               Ozna text do konca riadku' + cCrlf2 + ;
         ' Ctrl+End                Presun na koniec textu' + cCrlf2 + ;
         ' Shift+Ctrl+End          Ozna text od aktulnej pozcie do konca' + cCrlf2 + ;
         ' Backspace               Vymae znak vavo od kurzora' + cCrlf2 + ;
         ' Insert                  Prepna mezi "vkladanm" i "prepisom"' + cCrlf2 + ;
         ' Shift+Insert            Vymae oznaen text a nahrad ho textom' + cCrlf + ;
         '                         zo schrnky' + cCrlf2 + ;
         ' Ctrl+Insert             Kopruje oznaen text do schrnky' + cCrlf2 + ;
         ' Delete                  vymae znak vpravo od kurzora, alebo vymae' + cCrlf + ;
         '                         oznaen text bez koprovania do schrnky' + cCrlf+ ;
         ' Shift+Delete            Vymae oznaen text a zkopruje ho do schrnky' + cCrlf2 + ;
         ' Tab                     Zapisuje se ako znak v textu' + cCrlf2 + ;
         ' Ostatn klvesy         Ostatn klvesy obsahujce ASCII znaky se zapisuj' + cCrlf + ;
         '                         do textu ako odpovedajce im znaky' + cCrlf

   ELSEIF DC_LangSet() = DCLANG_CZECH

      cText := ;
         ' Klvesa                 Popis' + cCrlf + ;
         ' ------------------      -------------------------------------------' + cCrlf2 + ;
         ' ipka vlevo             Posune kursor o 1 znak doleva' + cCrlf2 + ;
         ' Shift+ipka vlevo       Ozna 1 znak vlevo' + cCrlf2 + ;
         ' Shift+Ctrl+ipka vlevo  Ozna 1 slovo vlevo' + cCrlf2 + ;
         ' ipka vpravo            Posune kursor o 1 znak doprava' + cCrlf2 + ;
         ' Shift+ipka vpravo      Ozna 1 znak vpravo' + cCrlf2 + ;
         ' Shift+Ctrl+ipka vpr.   Ozna 1 slovo vpravo' + cCrlf2 + ;
         ' ipka nahoru            Posun o 1 dek nahoru' + cCrlf2 + ;
         ' Shift+ipka nahoru      Ozna 1 dek nahoe' + cCrlf2 + ;
         ' ipka dolu              Posun o 1 dek dolu' + cCrlf2 + ;
         ' Shift+ipka dolu        Ozna 1 dek dole' + cCrlf2 + ;
         ' Page Up                 Posun o 1 stranu nahoru' + cCrlf2 + ;
         ' Ctrl+Page Up            Posun o 1 stranu doleva' + cCrlf2 + ;
         ' Page Down               Posun o 1 stranu dol' + cCrlf2 + ;
         ' Ctrl+Page Down          Posun o 1 stranu doprava' + cCrlf2 + ;
         ' Home                    Posun na zatek dku' + cCrlf2 + ;
         ' Shift+Home              Ozna vechny znaky do zatku dku' + cCrlf2 + ;
         ' Ctrl+Home               Pesun na zatek textu' + cCrlf2 + ;
         ' Shift+Ctrl+Home         Ozna text od zatku do aktuln pozice' + cCrlf2 + ;
         ' End                     Posun na konec dku' + cCrlf2 + ;
         ' Shift+End               Ozna text do konce dku' + cCrlf2 + ;
         ' Ctrl+End                Pesun na konec textu' + cCrlf2 + ;
         ' Shift+Ctrl+End          Ozna text od aktuln pozice do konce' + cCrlf2 + ;
         ' Backspace               Vymae znak vlevo od kursoru' + cCrlf2 + ;
         ' Insert                  Pepna mezi "vkldnm" i "pepisem"' + cCrlf2 + ;
         ' Shift+Insert            Vymae oznaen text a nahrad ho textem' + cCrlf + ;
         '                         ze schrnky' + cCrlf2 + ;
         ' Ctrl+Insert             Kopruje oznaen text do schrnky' + cCrlf2 + ;
         ' Delete                  vymae znak vpravo od kursoru, nebo vymae' + cCrlf + ;
         '                         oznaen text bez koprovn do schrnky' + cCrlf+ ;
         ' Shift+Delete            Vymae oznaen text a zkopruje ho do schrnky' + cCrlf2 + ;
         ' Tab                     Zapisuje se jako znak v textu' + cCrlf2 + ;
         ' Ostatn klvesy         Ostatn klvesy obsahujc ASCII znaky se zapisuj' + cCrlf + ;
         '                         do textu jako odpovdajc jim znaky' + cCrlf

   ELSE

      cText := ;
         ' Key                     Description' + cCrlf + ;
         ' ------------------      -------------------------------------------' + cCrlf2 + ;
         ' Left Arrow              Move cursor one character to the left' + cCrlf2 + ;
         ' Shift+Left Arrow        Select one character to the left' + cCrlf2 + ;
         ' Shift+Ctrl+Left Arrow   Select one word to the left' + cCrlf2 + ;
         ' Right Arrow             Move one character to the right' + cCrlf2 + ;
         ' Shift+Right Arrow       Select one character to the right' + cCrlf2 + ;
         ' Shift+Ctrl+Right Arrow  Select one word to the right' + cCrlf2 + ;
         ' Up Arrow                Move up one row' + cCrlf2 + ;
         ' Shift+Up Arrow          Select one row up' + cCrlf2 + ;
         ' Down Arrow              Move down one row' + cCrlf2 + ;
         ' Shift+Down Arrow        Select one row down' + cCrlf2 + ;
         ' Page Up                 Move one page up' + cCrlf2 + ;
         ' Ctrl+Page Up            Move one page to the left' + cCrlf2 + ;
         ' Page Down               Move one page down' + cCrlf2 + ;
         ' Ctrl+Page Down          Move one page to the right' + cCrlf2 + ;
         ' Home                    Move to beginning of current row' + cCrlf2 + ;
         ' Shift+Home              Select all characters to start of current row' + cCrlf2 + ;
         ' Ctrl+Home               Move to start of edit buffer' + cCrlf2 + ;
         ' Shift+Ctrl+Home         Select all characters to start of edit buffer' + cCrlf2 + ;
         ' End                     Move to end of current row' + cCrlf2 + ;
         ' Shift+End               Select all characters to end of current row' + cCrlf2 + ;
         ' Ctrl+End                Move to end of edit buffer' + cCrlf2 + ;
         ' Shift+Ctrl+End          Select all characters to end of edit buffer' + cCrlf2 + ;
         ' Backspace               Delete the character to the left of cursor' + cCrlf2 + ;
         ' Insert                  Toggle between "Insert" and "Overstrike"' + cCrlf2 + ;
         ' Shift+Insert            Delete selected characters and replace with' + cCrlf + ;
         '                         characters from the clipboard' + cCrlf2 + ;
         ' Ctrl+Insert             Copy marked characters to the clipboard' + cCrlf2 + ;
         ' Delete                  Delete the character to the right of cursor' + cCrlf + ;
         '                         or delete selected characters without copying' + cCrlf+ ;
         '                         them to the clipboard' + cCrlf2 + ;
         ' Shift+Delete            Delete selected characters and copy them' + cCrlf2 + ;
         '                         to the clipboard' + cCrlf2 + ;
         ' Tab                     Copied into the edit buffer as character' + cCrlf2 + ;
         ' Others                  Other keys containing ASCII characters are' + cCrlf + ;
         '                         copied to the edit buffer as characters' + cCrlf
   ENDIF

   oParent := SetAppWindow():setParent()
   nCol := (oParent:currentSize()[1]-600)/2
   nRow := (oParent:currentSize()[2]-400)/2

   oDialog := XbpDialog():new( oParent, , { nCol, nRow }, { 600, 340 }, , .F.)
   oDialog:title := 'Memo Editing Keys'
   oDialog:visible := .F.
   oDialog:create()
   drawingArea := oDialog:drawingArea
   drawingArea:setColorBG( GRA_CLR_PALEGRAY   )
   drawingArea:setFontCompoundName( "8.Courier" )
   oMle := XbpMLE():new( drawingArea, , { 10,40 }, { 570, 260 } )
   oMle:setEditable(.f.)
   oMle:create()
   oMle:setData(cText)
   oMle:show()
   oDialog:show()
   oButton := XbpPushButton():new( drawingArea, , {10,10}, {50,22} )
   oButton:caption := "Ok"
   oButton:create()
   oButton:activate := {||PostAppEvent( xbeP_Close,,,oDialog ) }

   nEvent := xbe_None
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
      IF (nEvent = xbeM_Motion .AND. mp1 == NIL) .OR. Valtype(oXbp) # 'O'
         LOOP
      ENDIF
      oXbp:handleEvent( nEvent, mp1, mp2 )
      IF nEvent = xbeP_Keyboard
         IF mp1 = K_ESC
            EXIT
         ENDIF
      ENDIF
   ENDDO
   oDialog:Destroy()
RETURN nil


// By John Lau
* **********************************************************************
* DC_XbpMLEC class
* **********************************************************************
CLASS DC_XbpMLEC FROM DC_XbpMLE

   EXPORTED:
   ** creation flags

   VAR    Get                                   // the imbeedded invisible service GET
   VAR    GetPos
   VAR    buffer
   VAR    original
   ** overloaded from XbpMle
   METHOD Init, Create                          // Lifecycle
   METHOD _Assign                               // Clipper GET compatability
ENDCLASS

* **********************************************************************
* Init method
* **********************************************************************
METHOD DC_XbpMLEC:Init( oParent, oOwner, aPos, aSize, aPP, lVisible, ;
      aGetList, nGetPointer, aOptions )

   DEFAULT aPP TO {}

   * initialisation of base class
   AAdd( aPP, { XBP_PP_COMPOUNDNAME, FONT_DEFFIXED_SMALL } )
   ::DC_XbpMle:init( oParent, oOwner, aPos, aSize, aPP, lVisible, ;
      aGetList, nGetPointer, aOptions )

RETURN self

* **********************************************************************
* Create method
* **********************************************************************
METHOD DC_XbpMLEC:Create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * ::XbpMle:autoKeyboard := .F.
   * create the SLE and disable keyboard handling
   ::DC_XbpMle:Create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::Get := InvisibleGet():New(,, ::Datalink, "",)
   * now initialize the get object
   ::DC_XbpMLE:XbpMLE:setData(::Get:buffer)
   ::getPos := ::DC_XbpMLE:XbpMLE:POS()
   ::buffer := ::DC_XbpMLE:XbpMLE:getData()
RETURN self

METHOD DC_XbpMLEC:_Assign( xValue )
   Eval(::datalink,xValue)
   DC_GetEditUpdated(.t.)
   ::setData()
RETURN self


